**IMPORTANT NOTE: This patch is intended only for Faspex version 4.4.2.**
**IMPORTANT NOTE: If you think your environment has been compromised, contact IBM Aspera support before applying the security fixes included in this patch.**

# FASPEX 4.4.2 PATCH Level 5
**Operating Systems:** Windows
**Date:** 01/04/2024

This patch includes the following fixes:

### Patch Level 5 Fixes

| GitHub Issue | Description|
| ---------- | ------------------------------------------------------------------------------------------------------------------------------ |
| Aspera/faspex4#543        |  Security improvements for CVE-2023-27522, CVE-2023-25690 |

### Patch Level 4 Fixes

| GitHub Issue | Description|
| ---------- | ------------------------------------------------------------------------------------------------------------------------------ |
| Aspera/faspex4#520        |  Security improvements - Faspex 4.4.2 PL 3 showing OAuth vulnerability CVE-2023-27871 |
| Aspera/faspex4#468        |  Security improvements - Faspex 4.4.2 PL 3 IP address access restriction bypass vulnerability PSIRT# PVR0438526 |

### Patch Level 3 Fixes

| GitHub Issue | Description|
| ---------- | ------------------------------------------------------------------------------------------------------------------------------ |
| Aspera/faspex4#446        | Return the `X-IBM-Aspera` HTTP header to show the server's current running version
| Aspera/faspex4#445        | Added a new rake task `asctl faspex:rake aspera:renew_secrets` to renew secrets and update relevant passwords in one command|
| Aspera/faspex4#443        | Read request parameters as the correct data type |
| Aspera/faspex4#440        | Enhance XML validation for endpoints that accept requests in XML format
| Aspera/faspex4#439        | Stop treating requests in XML format as request parameters|

### Patch Level 2 Fixes

| Jira Issue | Description                                                                                                                    |
| ---------- | ------------------------------------------------------------------------------------------------------------------------------ |
| FASPX-2054 | JQuery-UI: Using now jquery-ui v. 1.13.2                                                        |
| FASPX-2100 | YAML: Pre-auth RCE(Remote code execution) in /package_relay/relay_package due to insecure YAML deserialization has been supressed           |
| FASPX-2104 | XSS: Restrict render type to avoid to insecure rendering                                                       |
| FASPX-2087 | Apache: Using apache 2.4.54 now                                                       |
| FASPX-2095 | OpenSSL: Using openssl 1.1.1s now                                                     |
| FASPX-2096 | Zlib: Using zlib 1.2.13 now                                                     |

### Patch Level 1 Fixes

| Jira Issue | Description                                                                                                                    |
| ---------- | ------------------------------------------------------------------------------------------------------------------------------ |
| FASPX-2092 | Clickjacking: CSP frame-ancestors missing                                                        |

## PATCH INSTRUCTIONS
### Pre-requisite

1. Confirm the Faspex version you have currently installed. You must be on Faspex: 4.4.2.185316 to apply this patch. 
	
	    ```$ asctl faspex:version```

### Applying the patch for Windows systems:

1. Download the patch file (`IBM_Aspera_Faspex_4.4.2_Windows_Patch_Level_5.zip`) and unzip it.

2. Make sure to back up all the files in the Common folder (`C:\Program Files (x86)\Common Files\Aspera\Common`) and Faspex folder (`C:\Program Files (x86)\Aspera\Faspex\`).

3. Stop Faspex services:

    a. Go to **Control Panel > Administrative Tools > Services**.

    b. For every service with **IBM Aspera Faspex** in the name, right-click on the service and select **Stop** from the drop-down menu. (**Include** the **Apache** and **MySQL** services)

4. Replace existing files by copying patch files to the appropriate directories in Common folder (`C:\Program Files (x86)\Common Files\Aspera\Common`) and the Faspex folder (`C:\Program Files (x86)\Aspera\Faspex`).

5. Start MySQL service:

    a. Go to **Control Panel > Administrative Tools > Services**.

    b. Right-click on the **MySQL** service and select **Start** from the drop-down menu.

6. Run the following command to start Apache:

     Open **cmd** and run this command
    ```
    asctl apache:setup
    ```

7. Run the following command to upgrade Apache:

     Open **cmd** and run this command
    ```
    asctl apache:upgrade
    ```

8. Run the following command to get updated database schema:

    ```
    asctl faspex:migrate_database
    ```

9. Confirm the patch was applied by checking the patch level listed in the footer (beneath the version number).

© IBM Aspera. Copyright IBM Corp. 2009, 2023
